﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using FarPoint.Win.Spread;

namespace SpreadThread
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ExportPDF1(object filename)
        {
            FarPoint.Win.Spread.PrintInfo pi = new FarPoint.Win.Spread.PrintInfo();
            pi.PrintToPdf = true;
            pi.PdfWriteMode = FarPoint.Win.Spread.PdfWriteMode.New;
            pi.PdfWriteTo = FarPoint.Win.Spread.PdfWriteTo.File;
            pi.Orientation = FarPoint.Win.Spread.PrintOrientation.Landscape;

            pi.PdfFileName = filename.ToString();
            fpSpread1.Sheets[0].PrintInfo = pi;
            fpSpread1.PrintSheet(0);

            MessageBox.Show("文件导出完成！", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        // 使用 Thread 导出 PDF 文件
        private void export1ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog dlgSave = new SaveFileDialog();
            dlgSave.FileName = string.Empty;
            dlgSave.Filter = "PDF文件(*.pdf)|*.pdf";
            if (dlgSave.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                System.Threading.ParameterizedThreadStart pts = new System.Threading.ParameterizedThreadStart(ExportPDF1);
                System.Threading.Thread thread = new System.Threading.Thread(pts);
                thread.Start(dlgSave.FileName);
            }
        }

        // 使用 BackgroundWorker 导出 PDF 文件
        private void export2ToolStripMenuItem_Click(object sender, EventArgs e)
        {

            SaveFileDialog dlgSave = new SaveFileDialog();
            dlgSave.FileName = string.Empty;
            dlgSave.Filter = "PDF文件(*.pdf)|*.pdf";
            if (dlgSave.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                BackgroundWorker bw = new BackgroundWorker();
                bw.DoWork += new DoWorkEventHandler(bw_DoWork);
                bw.RunWorkerAsync(dlgSave.FileName);
            }

        }

        void bw_DoWork(object sender, DoWorkEventArgs e)
        {
            ExportPDF1(e.Argument);
        }
    }
}
